#ifndef CRAPPYMODULE_H
#define CRAPPYMODULE_H

#include "module.h"
#include "lights.h"

class PhongEntity;

class CrappyModule : public Module
{
public:
    CrappyModule(Lights::Light* myDirLight, Lights* myPointLights);

    void addEntity(PhongEntity* myEntity);
    void clearEntities();

    virtual void renderGL(Camera* myCamera);
    virtual bool requiresModernOpenGL() {return false;}

private:
    Lights::Light* dirLight;
    Lights* pointLights;
    GLuint dirLightLocation;
    GLuint nbPointLightsLocation;
    GLuint pointLightsLocation;
    std::vector<PhongEntity*> entities;
};

#endif // CRAPPYMODULE_H
